#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/RowColumn.h>
#include <Xm/MainW.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleB.h>
#include <Xm/ToggleBG.h>
#include <Xm/DrawingA.h>
#include <Xm/CascadeBG.h>
#include <Xm/SeparatoG.h>
#include <Xm/Frame.h>
#include <Xm/BulletinB.h>
#include <Xm/Scale.h>
#include <Xm/ScrollBar.h>
#include <Xm/Form.h>
#include <Xm/List.h>
#include <Xm/FileSB.h>
#include <Xm/Protocols.h>
#include <Xm/MwmUtil.h>


/* Structure of mib_Widget */
/*****************************************************************************/

typedef struct _mib_Widget {
  char		*mib_class;	/* name of mib class (Button, TextBox, etc..)*/
  int		 mib_class_num; /* class number for ez reference :) */
  int		 mib_mynum;	/* numbering for storage format */
  Widget	 me;		/* Xt widget */
  int		 mib_selected;	/* is selected */
  int		 mib_resizing;  /* is resizing 1, or being moved 0 */
  int		 mib_resizetype;/* 1  = upper left, 2 = upper, 3 = ... */
  int		 mib_allowresize; /* can this widget be resized ? */

  int		 clkx, clky;	/* where user clicked */

  void		*myres;		/* my resources (different for each widget) */

  char		*name;		/* reference name of this widget */
  int		 width, height;	/* width and height */

  int   topAttachment, bottomAttachment, leftAttachment, rightAttachment;
				/* attachments 1=attached 0=not-attached */

  int   topOffset, bottomOffset, leftOffset, rightOffset;
				/* offsets if attached */

  struct _mib_Widget *parent;   /* pointer to parent */
  struct _mib_Widget *sibling;  /* remaining linked list of sibling widgets */
  struct _mib_Widget *prev;	/* previous sibling or parent */
  struct _mib_Widget *child;	/* linked list of children widgets */
} mib_Widget;

/* mib_load_interface function */
/*****************************************************************************/

mib_Widget *mib_load_interface(Widget, char *, int);

#define MI_FROMFILE		1
#define MI_EDITFROMFILE		2
#define MI_FROMSTRING		3
#define MI_EDITFROMSTRING	4
